unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses WbemScripting_TLB, activex;

function getPropValue(sprop:ISWbemProperty):string;
var sValue:string;
    count:integer;
begin
  sValue := '';
  if VarIsNull(SProp.Get_Value) then
    sValue := '<empty>'
  else
  case SProp.CIMType of
    wbemCimtypeSint8, wbemCimtypeUint8, wbemCimtypeSint16, wbemCimtypeUint16,
    wbemCimtypeSint32, wbemCimtypeUint32, wbemCimtypeSint64:
      sValue := IntToStr(SProp.Get_Value);
    wbemCimtypeString, wbemCimtypeUint64:
      if VarIsArray(SProp.Get_Value) then
      begin
        if VarArrayHighBound(SProp.Get_Value, 1) > 0 then
          for Count := 1 to VarArrayHighBound(SProp.Get_Value, 1) do
            sValue := sValue + ' ' + SProp.Get_Value[Count];
      end
    else
      sValue :=  SProp.Get_Value;
    wbemCimtypeDatetime:sValue:=SProp.Get_Value//DateTimeToStr(SProp.Get_Value)
  else
      Exception.Create('Unknown type');
  end; {case}
  result:=sValue;
end;

procedure getList(owner:TComponent; className,RemoteMachine,RemoteUser,RemotePassword:string; list:TStrings);
var
  Locator: TSWbemLocator;
  SinkClasses: TSWbemSink;

  Services:   ISWbemServices;
  ObjectSet:  ISWbemObjectSet;
  SObject:    ISWbemObject;
  propSet :   ISWbemPropertySet;
  SProp:      ISWbemProperty;
  propEnum,
  Enum:       IEnumVariant;
  tempObj:    OleVariant;
  Value:      Cardinal;

  sValue:     String;
  strQuery:   WideString;
  i:byte;
begin
  for i:=1 to list.count do
    list.Objects[i-1]:=TStringList.create;
  Locator:=TSWbemLocator.Create(owner);
  SinkClasses:=TSWbemSink.Create(owner);

  try
    SinkClasses.Cancel;

    if RemoteMachine='' then
      RemoteMachine:='.';// local machine
    Services := Locator.ConnectServer(RemoteMachine, 'root\MicrosoftIISv2', RemoteUser, RemotePassword, '',
      '', 0, nil);
    ObjectSet := Services.InstancesOf(className, wbemFlagReturnImmediately or wbemQueryFlagShallow, nil);

    Enum :=  (ObjectSet._NewEnum) as IEnumVariant;
    while (Enum.Next(1, tempObj, Value) = S_OK) do
    begin
      SObject := IUnknown(tempObj) as SWBemObject;
      propSet := SObject.Properties_;
      propEnum := (propSet._NewEnum) as IEnumVariant;
      for i:=1 to list.count do
      begin
        SProp:=propSet.Item(list[i-1],0);
        // now get the value of the property
        sValue:=getPropValue(SProp);
        TStrings(list.objects[i-1]).add(sValue);
      end;
    end; {while Enum}

    strQuery := 'SELECT * FROM __InstanceCreationEvent within 5 WHERE TargetInstance' +
      ' ISA "'+className+'"';
    Services.ExecNotificationQueryAsync(SinkClasses.DefaultInterface, strQuery, 'WQL', 0, nil, nil);
      strQuery := 'SELECT * FROM __InstanceDeletionEvent within 5 WHERE TargetInstance' +
      ' ISA "'+className+'"';
    Services.ExecNotificationQueryAsync(SinkClasses.DefaultInterface, strQuery, 'WQL', 0, nil, nil);
  finally
  end; {try}
  Locator.Free;
  SinkClasses.Free;
  Services:=nil;// make sure the references are decreased
  ObjectSet:=nil;
  SObject:=nil;
  propSet:=nil;
  propEnum:=nil;
  SProp:=nil;
  enum:=nil;
end;

function getwebsite(name:string; k:TStrings):string;
var i:integer;
begin
  result:='<ERROR>';
  for i:=1 to TStrings(k.Objects[0]).count do
    if pos(TStrings(k.Objects[0])[i-1],name)>0 then
    begin
      result:=TStrings(k.Objects[1])[i-1];
      break;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var k,t:TStringList; i:integer; s:string;
begin
  listbox1.Clear;
  k:=TStringList.create;
  t:=TStringList.create;
  k.add('Name');
  k.add('ServerComment');
  getList(self, 'IIsWebServerSetting', '', '', '', k);
  t.add('AppFriendlyName');
  t.add('Name');
  t.add('Path');
  getList(self, 'IIsWebVirtualDirSetting', '', '', '', t);
  for i:=1 to TStrings(t.objects[0]).Count do
  begin
    s:='('+TStrings(t.objects[0])[i-1]+') '+getwebsite(TStrings(t.objects[1])[i-1],k)+' ['+TStrings(t.objects[1])[i-1]+'] has path '+TStrings(t.objects[2])[i-1];
    listbox1.items.add(s);
  end;
  k.free;
  t.free;
end;

end.
